---
title: 'HTMLInputElement: invalid event'
slug: Web/API/HTMLInputElement/invalid_event
tags:
  - API
  - Constraint Validation API
  - Constraint validation
  - Event
  - Forms
  - Reference
  - invalid
---
<p>{{APIRef}}</p>

<p>The <strong><code>invalid</code></strong> event fires when a submittable element has been checked for validity and doesn't satisfy its constraints.</p>

<table class="properties">
 <tbody>
  <tr>
   <th>Bubbles</th>
   <td>No</td>
  </tr>
  <tr>
   <th>Cancelable</th>
   <td>Yes</td>
  </tr>
  <tr>
   <th>Interface</th>
   <td>{{DOMxRef("Event")}}</td>
  </tr>
  <tr>
   <th>Event handler property</th>
   <td>{{domxref("GlobalEventHandlers.oninvalid")}}</td>
  </tr>
 </tbody>
</table>

<p>This event can be useful for displaying a summary of the problems with a form on submission. When a form is submitted, <code>invalid</code> events are fired at each form control that is invalid. The validity of submittable elements is checked before submitting their owner {{HtmlElement("form")}}, or after the <a href="/en-US/docs/HTML/Forms_in_HTML#Constraint_Validation_API"><code>checkValidity()</code></a> method of the element or its owner <code>&lt;form&gt;</code> is called.</p>

<p>It is not checked on {{domxref("Element/blur_event", "blur")}}.</p>

<h2 id="Examples">Examples</h2>

<p>If a form is submitted with an invalid value, the submittable elements are checked and, if an error is found, the <code>invalid</code> event will fire on the <code>invalid</code> element. In this example, when an invalid event fires because of an invalid value in the input, the invalid value is logged.</p>

<h3 id="HTML">HTML</h3>

<pre class="brush: html notranslate">&lt;form action="#"&gt;
  &lt;ul&gt;
    &lt;li&gt;&lt;label&gt;Enter an integer between 1 and 10: &lt;input type="number" min="1" max="10" required&gt;&lt;/label&gt;&lt;/li&gt;
    &lt;li&gt;&lt;input type="submit" value="submit"&gt;&lt;/li&gt;
  &lt;/ul&gt;
&lt;/form&gt;&lt;p id="log"&gt;&lt;/p&gt;</pre>

<h3 id="JavaScript">JavaScript</h3>

<pre class="brush: js notranslate">const input = document.querySelector('input')
const log = document.getElementById('log')

input.addEventListener('invalid', logValue)

function logValue(e) {
  log.textContent += e.target.value
}</pre>

<h3 id="Result">Result</h3>

<p>{{EmbedLiveSample("Examples")}}</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{ SpecName('HTML WHATWG', 'forms.html#the-constraint-validation-api', 'Invalid event') }}</td>
   <td>{{Spec2('HTML WHATWG')}}</td>
   <td></td>
  </tr>
  <tr>
   <td>{{ SpecName('HTML5.1', 'sec-forms.html#the-constraint-validation-api', 'Invalid event') }}</td>
   <td>{{Spec2('HTML5.1')}}</td>
   <td></td>
  </tr>
  <tr>
   <td>{{ SpecName('HTML5 W3C', 'forms.html#the-constraint-validation-api', 'Invalid event') }}</td>
   <td>{{Spec2('HTML5 W3C')}}</td>
   <td></td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.HTMLInputElement.invalid_event")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>HTML {{HtmlElement("form")}} element</li>
 <li>Related event: {{domxref("HTMLFormElement/submit_event", "submit")}}</li>
 <li>CSS {{cssxref(":invalid")}} pseudo class</li>
</ul>
